#ifndef H_LINGO_PLATFORM_WARNINGS
#define H_LINGO_PLATFORM_WARNINGS

#include <lingo/platform/compiler.hpp>
#include <lingo/platform/pragma.hpp>
#include <lingo/platform/preprocessor.hpp>

#if LINGO_COMPILER == LINGO_COMPILER_MSVC
#define LINGO_WARNINGS_PUSH_MSVC LINGO_PRAGMA(warning(push))
#define LINGO_WARNINGS_DISABLE_MSVC(x) LINGO_PRAGMA(warning(disable: x))
#define LINGO_WARNINGS_POP_MSVC LINGO_PRAGMA(warning(pop))
#else
#define LINGO_WARNINGS_PUSH_MSVC
#define LINGO_WARNINGS_DISABLE_MSVC(x)
#define LINGO_WARNINGS_POP_MSVC
#endif

#if LINGO_COMPILER == LINGO_COMPILER_CLANG
#define LINGO_WARNINGS_PUSH_CLANG LINGO_PRAGMA(clang diagnostic push)
#define LINGO_WARNINGS_DISABLE_CLANG(x) LINGO_PRAGMA(clang diagnostic ignored "-W" LINGO_STRINGIFY(x))
#define LINGO_WARNINGS_POP_CLANG LINGO_PRAGMA(clang diagnostic pop)
#else
#define LINGO_WARNINGS_PUSH_CLANG
#define LINGO_WARNINGS_DISABLE_CLANG(x)
#define LINGO_WARNINGS_POP_CLANG
#endif

#define LINGO_WARNINGS_PUSH_AND_DISABLE_MSVC(x) LINGO_WARNINGS_PUSH_MSVC LINGO_WARNINGS_DISABLE_MSVC(x)
#define LINGO_WARNINGS_PUSH_AND_DISABLE_CLANG(x) LINGO_WARNINGS_PUSH_CLANG LINGO_WARNINGS_DISABLE_CLANG(x)

#endif